# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           karaf
Summary:        Apache Karaf OSGi runtime
Url:            http://karaf.apache.org
Version:        2.2.0
Release:        1%{?dist}
Epoch:          1
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        karaf-2.2.0.tgz
# svn export http://svn.apache.org/repos/asf/karaf/tags/karaf-2.2.0/
# tar czf karaf-2.2.0.tgz karaf-2.2.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://repo1.maven.org/maven2/org/eclipse/osgi/org.eclipse.osgi/3.6.0.v20100517/org.eclipse.osgi-3.6.0.v20100517.jar
#Source4:        http://repo1.maven.org/maven2/org/apache/servicemix/bundles/org.apache.servicemix.bundles.junit/4.7_2/org.apache.servicemix.bundles.junit-4.7_2.jar
#Source5:        http://archive.apache.org/dist/aries/org.apache.aries.blueprint-0.3.jar
Source4:        https://repository.apache.org/content/repositories/releases/org/apache/karaf/manual/2.2.0/manual-2.2.0.pdf
Source5:        https://repository.apache.org/content/repositories/releases/org/apache/karaf/manual/2.2.0/manual-2.2.0.html

Patch0:         karaf-pom.patch
Patch1:         karaf-jaas-config-pom.patch
Patch2:         karaf-jaas-modules-pom.patch
Patch3:         karaf-shell-console-pom.patch
Patch4:         karaf-features-core-pom.patch
Patch5:         karaf-admin-core-pom.patch
Patch6:         karaf-deployer-spring-pom.patch
Patch7:         karaf-deployer-blueprint-pom.patch
Patch8:         karaf-deployer-features-pom.patch
Patch9:         karaf-deployer-kar-pom.patch
Patch10:        karaf-shell-commands-pom.patch
Patch11:        karaf-shell-osgi-pom.patch
Patch12:        karaf-shell-ssh-pom.patch
Patch13:        karaf-shell-dev-pom.patch
Patch14:        karaf-client-pom.patch
Patch15:        karaf-webconsole-branding-pom.patch
Patch16:        karaf-webconsole-features-pom.patch
Patch17:        karaf-webconsole-gogo-pom.patch
Patch18:        karaf-webconsole-admin-pom.patch
Patch19:        karaf-tooling-features-maven-plugin-AddFeaturesToRepoMojo.patch
Patch20:        karaf-demos-web-pom.patch
Patch21:        karaf-tooling-pom.patch
Patch22:        karaf-archetypes-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant17 >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-plugin-tools
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-archetype2
BuildRequires:  mojo-maven2-plugin-exec
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  easymock-classextension2
BuildRequires:  geronimo-genesis
BuildRequires:  plexus-resources
BuildRequires:  maven-shared-downloader

BuildRequires:  apache-felix-bundlerepository
BuildRequires:  apache-felix-configadmin
BuildRequires:  apache-felix-eventadmin
BuildRequires:  apache-felix-fileinstall
BuildRequires:  apache-felix-framework
BuildRequires:  apache-felix-gogo
BuildRequires:  apache-felix-main
BuildRequires:  apache-felix-metatype
BuildRequires:  apache-felix-shell
BuildRequires:  apache-felix-utils
BuildRequires:  apache-felix-webconsole
BuildRequires:  apache-sshd
BuildRequires:  aries-blueprint
BuildRequires:  aries-parent
BuildRequires:  aries-testsupport
BuildRequires:  icu4j
BuildRequires:  jasypt
BuildRequires:  jline2
BuildRequires:  kxml2
BuildRequires:  ops4j-pax-logging
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  ops4j-pax-url
BuildRequires:  ops4j-pax-web
BuildRequires:  org.osgi.core
BuildRequires:  servlet_2_5_api
BuildRequires:  spring-osgi
BuildRequires:  tanukiwrapper

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  apache-felix-bundlerepository
Requires:  apache-felix-configadmin
Requires:  apache-felix-eventadmin
Requires:  apache-felix-fileinstall
Requires:  apache-felix-framework
Requires:  apache-felix-gogo
Requires:  apache-felix-main
Requires:  apache-felix-metatype
Requires:  apache-felix-shell
Requires:  apache-felix-utils
Requires:  apache-felix-webconsole
Requires:  apache-sshd
Requires:  aries-blueprint
Requires:  aries-parent
Requires:  jasypt
Requires:  jline2
Requires:  ops4j-pax-logging
Requires:  ops4j-pax-swissbox
Requires:  ops4j-pax-url
Requires:  ops4j-pax-web
Requires:  org.osgi.core
Requires:  spring-osgi
Requires:  tanukiwrapper

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Apache Karaf is a small OSGi based runtime which provides a
lightweight container onto which various components and 
applications can be deployed.
Here is a short list of features supported by the Karaf:
* Hot deployment: Karaf supports hot deployment of OSGi 
  bundles by monitoring jar files inside the [home]/deploy 
  directory. Each time a jar is copied in this folder, it 
  will be installed inside the runtime. You can then update 
  or delete it and changes will be handled automatically.
  In addition, the Karaf also supports exploded bundles and 
  custom deployers (blueprint and spring ones are included 
  by default).
* Dynamic configuration: Services are usually configured 
  through the ConfigurationAdmin OSGi service. Such 
  configuration can be defined in Karaf using property 
  files inside the [home]/etc directory. These configurations 
  are monitored and changes on the properties files will be 
  propagated to the services.
* Logging System: using a centralized logging back end 
  supported by Log4J, Karaf supports a number of different 
  APIs (JDK 1.4, JCL, SLF4J, Avalon, Tomcat, OSGi)
* Provisioning: Provisioning of libraries or applications 
  can be done through a number of different ways, by which 
  they will be downloaded locally, installed and started.
* Native OS integration: Karaf can be integrated into your 
  own Operating System as a service so that the lifecycle 
  will be bound to your Operating System.
* Extensible Shell console: Karaf features a nice text 
  console where you can manage the services, install new 
  applications or libraries and manage their state. This 
  shell is easily extensible by deploying new commands 
  dynamically along with new features or applications.
* Remote access: use any SSH client to connect to Karaf 
  and issue commands in the console
* Security framework based on JAAS
* Managing instances: Karaf provides simple commands for 
  managing multiple instances. You can easily create, 
  delete, start and stop instances of Karaf through the 
  console.
* Supports the latest OSGi 4.2 containers: Apache Felix 
  Framework 3.0 and Eclipse Equinox 3.6

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7
%patch8 -b .sav8
%patch9 -b .sav9
rm deployer/kar/src/test/java/org/apache/karaf/deployer/kar/KarArtifactInstallerTest.java
# KarArtifactInstallerTest requires easymock3 ?
%patch10 -b .sav10
%patch11 -b .sav11
%patch12 -b .sav12
%patch13 -b .sav13
%patch14 -b .sav14
%patch15 -b .sav15
%patch16 -b .sav16
%patch17 -b .sav17
%patch18 -b .sav18
%patch19 -b .sav19
%patch20 -b .sav20
%patch21 -b .sav21
%patch22 -b .sav22

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_OPTS="-Xmx512m -XX:MaxPermSize=128m"
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/org/eclipse/osgi/3.6.0.v20100517/
cp %{SOURCE3} $MAVEN_REPO_LOCAL/org/eclipse/osgi/3.6.0.v20100517/osgi-3.6.0.v20100517.jar
mkdir -p $MAVEN_REPO_LOCAL/org/apache/karaf/manual/2.2.0/
cp %{SOURCE4} $MAVEN_REPO_LOCAL/org/apache/karaf/manual/2.2.0/manual-2.2.0.pdf
cp %{SOURCE5} $MAVEN_REPO_LOCAL/org/apache/karaf/manual/2.2.0/manual-2.2.0.html

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -DobrRepository=NONE \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.apache.karaf karaf %{version} JPP/%{name} karaf
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-karaf.pom

%add_to_maven_depmap org.apache.karaf.admin admin %{version} JPP/%{name} admin
install -m 644 admin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-admin.pom

%add_to_maven_depmap org.apache.karaf.admin org.apache.karaf.admin.command %{version} JPP/%{name} org.apache.karaf.admin.command
install -m 644 admin/command/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.admin.command.pom
install -m 644 admin/command/target/org.apache.karaf.admin.command-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.admin org.apache.karaf.admin.core %{version} JPP/%{name} org.apache.karaf.admin.core
install -m 644 admin/core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.admin.core.pom
install -m 644 admin/core/target/org.apache.karaf.admin.core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.admin org.apache.karaf.admin.management %{version} JPP/%{name} org.apache.karaf.admin.management
install -m 644 admin/management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.admin.management.pom
install -m 644 admin/management/target/org.apache.karaf.admin.management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf archetypes %{version} JPP/%{name} archetypes
install -m 644 archetypes/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetypes.pom

%add_to_maven_depmap org.apache.karaf.archetypes org.apache.karaf.admin.archetypes-command %{version} JPP/%{name} archetypes-command
install -m 644 archetypes/command/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetypes-command.pom
install -m 644 archetypes/command/target/archetypes-command-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf org.apache.karaf.client %{version} JPP/%{name} org.apache.karaf.client
install -m 644 client/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.client.pom
install -m 644 client/target/org.apache.karaf.client-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.deployer deployer %{version} JPP/%{name} deployer
install -m 644 deployer/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-deployer.pom

%add_to_maven_depmap org.apache.karaf.deployer org.apache.karaf.deployer.blueprint %{version} JPP/%{name} org.apache.karaf.deployer.blueprint
install -m 644 deployer/blueprint/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.deployer.blueprint.pom
install -m 644 deployer/blueprint/target/org.apache.karaf.deployer.blueprint-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.deployer org.apache.karaf.deployer.features %{version} JPP/%{name} org.apache.karaf.deployer.features
install -m 644 deployer/features/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.deployer.features.pom
install -m 644 deployer/features/target/org.apache.karaf.deployer.features-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.deployer org.apache.karaf.deployer.kar %{version} JPP/%{name} org.apache.karaf.deployer.kar
install -m 644 deployer/kar/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.deployer.kar.pom
install -m 644 deployer/kar/target/org.apache.karaf.deployer.kar-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.deployer org.apache.karaf.deployer.spring %{version} JPP/%{name} org.apache.karaf.deployer.spring
install -m 644 deployer/spring/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.deployer.spring.pom
install -m 644 deployer/spring/target/org.apache.karaf.deployer.spring-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.deployer org.apache.karaf.deployer.wrap %{version} JPP/%{name} org.apache.karaf.deployer.wrap
install -m 644 deployer/wrap/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.deployer.wrap.pom
install -m 644 deployer/wrap/target/org.apache.karaf.deployer.wrap-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.diagnostic diagnostic %{version} JPP/%{name} diagnostic
install -m 644 diagnostic/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-diagnostic.pom

%add_to_maven_depmap org.apache.karaf.diagnostic org.apache.karaf.diagnostic.command %{version} JPP/%{name} org.apache.karaf.diagnostic.command
install -m 644 diagnostic/command/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.diagnostic.command.pom
install -m 644 diagnostic/command/target/org.apache.karaf.diagnostic.command-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.diagnostic org.apache.karaf.diagnostic.common %{version} JPP/%{name} org.apache.karaf.diagnostic.common
install -m 644 diagnostic/common/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.diagnostic.common.pom
install -m 644 diagnostic/common/target/org.apache.karaf.diagnostic.common-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.diagnostic org.apache.karaf.diagnostic.core %{version} JPP/%{name} org.apache.karaf.diagnostic.core
install -m 644 diagnostic/core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.diagnostic.core.pom
install -m 644 diagnostic/core/target/org.apache.karaf.diagnostic.core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.diagnostic org.apache.karaf.diagnostic.management %{version} JPP/%{name} org.apache.karaf.diagnostic.management
install -m 644 diagnostic/management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.diagnostic.management.pom
install -m 644 diagnostic/management/target/org.apache.karaf.diagnostic.management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf org.apache.karaf.exception %{version} JPP/%{name} org.apache.karaf.exception
install -m 644 exception/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.exception.pom
install -m 644 exception/target/org.apache.karaf.exception-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.features features %{version} JPP/%{name} features
install -m 644 features/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-features.pom

%add_to_maven_depmap org.apache.karaf.features org.apache.karaf.features.command %{version} JPP/%{name} org.apache.karaf.features.command
install -m 644 features/command/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.features.command.pom
install -m 644 features/command/target/org.apache.karaf.features.command-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.features org.apache.karaf.features.core %{version} JPP/%{name} org.apache.karaf.features.core
install -m 644 features/core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.features.core.pom
install -m 644 features/core/target/org.apache.karaf.features.core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.features org.apache.karaf.features.management %{version} JPP/%{name} org.apache.karaf.features.management
install -m 644 features/management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.features.management.pom
install -m 644 features/management/target/org.apache.karaf.features.management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.features org.apache.karaf.features.obr %{version} JPP/%{name} org.apache.karaf.features.obr
install -m 644 features/obr/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.features.obr.pom
install -m 644 features/obr/target/org.apache.karaf.features.obr-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.jaas jaas %{version} JPP/%{name} jaas
install -m 644 jaas/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jaas.pom

%add_to_maven_depmap org.apache.karaf.jaas org.apache.karaf.jaas.boot %{version} JPP/%{name} org.apache.karaf.jaas.boot
install -m 644 jaas/boot/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.jaas.boot.pom
install -m 644 jaas/boot/target/org.apache.karaf.jaas.boot-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.jaas org.apache.karaf.jaas.command %{version} JPP/%{name} org.apache.karaf.jaas.command
install -m 644 jaas/command/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.jaas.command.pom
install -m 644 jaas/command/target/org.apache.karaf.jaas.command-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.jaas org.apache.karaf.jaas.config %{version} JPP/%{name} org.apache.karaf.jaas.config
install -m 644 jaas/config/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.jaas.config.pom
install -m 644 jaas/config/target/org.apache.karaf.jaas.config-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.jaas org.apache.karaf.jaas.jasypt %{version} JPP/%{name} org.apache.karaf.jaas.jasypt
install -m 644 jaas/jasypt/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.jaas.jasypt.pom
install -m 644 jaas/jasypt/target/org.apache.karaf.jaas.jasypt-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.jaas org.apache.karaf.jaas.modules %{version} JPP/%{name} org.apache.karaf.jaas.modules
install -m 644 jaas/modules/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.jaas.modules.pom
install -m 644 jaas/modules/target/org.apache.karaf.jaas.modules-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf org.apache.karaf.main %{version} JPP/%{name} org.apache.karaf.main
install -m 644 main/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.main.pom
install -m 644 main/target/org.apache.karaf.main-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf org.apache.karaf.management %{version} JPP/%{name} org.apache.karaf.management
install -m 644 management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.management.pom
install -m 644 management/target/org.apache.karaf.management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell shell %{version} JPP/%{name} shell
install -m 644 shell/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-shell.pom

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.commands %{version} JPP/%{name} org.apache.karaf.shell.commands
install -m 644 shell/commands/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.commands.pom
install -m 644 shell/commands/target/org.apache.karaf.shell.commands-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.config %{version} JPP/%{name} org.apache.karaf.shell.config
install -m 644 shell/config/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.config.pom
install -m 644 shell/config/target/org.apache.karaf.shell.config-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.console %{version} JPP/%{name} org.apache.karaf.shell.console
install -m 644 shell/console/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.console.pom
install -m 644 shell/console/target/org.apache.karaf.shell.console-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.dev %{version} JPP/%{name} org.apache.karaf.shell.dev
install -m 644 shell/dev/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.dev.pom
install -m 644 shell/dev/target/org.apache.karaf.shell.dev-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.log %{version} JPP/%{name} org.apache.karaf.shell.log
install -m 644 shell/log/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.log.pom
install -m 644 shell/log/target/org.apache.karaf.shell.log-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.obr %{version} JPP/%{name} org.apache.karaf.shell.obr
install -m 644 shell/obr/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.obr.pom
install -m 644 shell/obr/target/org.apache.karaf.shell.obr-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.osgi %{version} JPP/%{name} org.apache.karaf.shell.osgi
install -m 644 shell/osgi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.osgi.pom
install -m 644 shell/osgi/target/org.apache.karaf.shell.osgi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.packages %{version} JPP/%{name} org.apache.karaf.shell.packages
install -m 644 shell/packages/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.packages.pom
install -m 644 shell/packages/target/org.apache.karaf.shell.packages-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.ssh %{version} JPP/%{name} org.apache.karaf.shell.ssh
install -m 644 shell/ssh/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.ssh.pom
install -m 644 shell/ssh/target/org.apache.karaf.shell.ssh-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.web %{version} JPP/%{name} org.apache.karaf.shell.web
install -m 644 shell/web/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.web.pom
install -m 644 shell/web/target/org.apache.karaf.shell.web-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.shell org.apache.karaf.shell.wrapper %{version} JPP/%{name} org.apache.karaf.shell.wrapper
install -m 644 shell/wrapper/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.shell.wrapper.pom
install -m 644 shell/wrapper/target/org.apache.karaf.shell.wrapper-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.tooling tooling %{version} JPP/%{name} tooling
install -m 644 tooling/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tooling.pom

%add_to_maven_depmap org.apache.karaf.tooling cmdhelp-maven-plugin %{version} JPP/%{name} cmdhelp-maven-plugin
install -m 644 tooling/cmdhelp-maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-cmdhelp-maven-plugin.pom
install -m 644 tooling/cmdhelp-maven-plugin/target/cmdhelp-maven-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.tooling features-maven-plugin %{version} JPP/%{name} features-maven-plugin
install -m 644 tooling/features-maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-features-maven-plugin.pom
install -m 644 tooling/features-maven-plugin/target/features-maven-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf org.apache.karaf.util %{version} JPP/%{name} org.apache.karaf.util
install -m 644 util/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.util.pom
install -m 644 util/target/org.apache.karaf.util-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.webconsole webconsole %{version} JPP/%{name} webconsole
install -m 644 webconsole/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-webconsole.pom

%add_to_maven_depmap org.apache.karaf.webconsole org.apache.karaf.webconsole.admin %{version} JPP/%{name} org.apache.karaf.webconsole.admin
install -m 644 webconsole/admin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.webconsole.admin.pom
install -m 644 webconsole/admin/target/org.apache.karaf.webconsole.admin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.webconsole org.apache.karaf.webconsole.branding %{version} JPP/%{name} org.apache.karaf.webconsole.branding
install -m 644 webconsole/branding/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.webconsole.branding.pom
install -m 644 webconsole/branding/target/org.apache.karaf.webconsole.branding-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.webconsole org.apache.karaf.webconsole.console %{version} JPP/%{name} org.apache.karaf.webconsole.console
install -m 644 webconsole/console/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.webconsole.console.pom
install -m 644 webconsole/console/target/org.apache.karaf.webconsole.console-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.webconsole org.apache.karaf.webconsole.features %{version} JPP/%{name} org.apache.karaf.webconsole.features
install -m 644 webconsole/features/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.webconsole.features.pom
install -m 644 webconsole/features/target/org.apache.karaf.webconsole.features-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.apache.karaf.webconsole org.apache.karaf.webconsole.gogo %{version} JPP/%{name} org.apache.karaf.webconsole.gogo
install -m 644 webconsole/gogo/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.apache.karaf.webconsole.gogo.pom
install -m 644 webconsole/gogo/target/org.apache.karaf.webconsole.gogo-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Mon Jun 27 2011 Ralph Apel <r.apel at r-apel.de> 0:2.2.0-1
- First release
